unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLPolyhedron, GLScene, GLObjects, GLCoordinates, GLCrossPlatform,
  BaseClasses, GLWin32Viewer, ComCtrls, ExtCtrls, StdCtrls, GLGeomObjects,
  AsyncTimer;

const
  SLin : string = #$0D+#$0A;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLPlane1: TGLPlane;
    GLDummyCube1: TGLDummyCube;
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    Button1: TButton;
    Label1: TLabel;
    AsyncTimer1: TAsyncTimer;
    GLDummyCube2: TGLDummyCube;
    GLCylinder1: TGLCylinder;
    GLCylinder2: TGLCylinder;
    GLCylinder3: TGLCylinder;
    Label2: TLabel;
    Label3: TLabel;
    GLSphere1: TGLSphere;
    GLSphere2: TGLSphere;
    Label4: TLabel;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AsyncTimer1Timer(Sender: TObject);
  private
    { Private declarations }
    px,py   : integer;
    omega,t : single;
    Tr,per  : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Per := 2.5;
  Tr  := Per/2;
  omega := 2*Pi/(Per*25);
  AsyncTimer1.Interval := 40; // milisegundos
  t := 0;

  GLLightSource1.Diffuse.SetColor(0.5,0.5,0.5);
  TrackBar1.Position := 25;

  Label4.Caption := 'Animacin de una Pierna Sinttica '  + SLin+
                    'mediante dos funciones cosenoidales '+ SLin+
                    'usando un rbol de objetos '         + SLin+
                    'Curso Animacin FCC BUAP'            + SLin+
                    '(Con el Botn IZQ del Ratn Rotar)' ;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
  L : single;
begin
  L := TrackBar1.Position/50;
  GLLightSource1.Diffuse.SetColor(L,L,L);

  Label3.Caption := FloatToStrF(L,ffFixed,2,2);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = '>>'
    then begin
      Button1.Caption := '||';
      AsyncTimer1.Enabled := true;
    end
    else begin
      Button1.Caption := '>>';
      AsyncTimer1.Enabled := false;
    end;

end;

procedure TForm1.AsyncTimer1Timer(Sender: TObject);
var
  alf,  bet  : single;
begin
  alf := -15*cos(omega*(t-Tr)) + 15;
  GLCylinder2.PitchAngle := alf;

  bet :=  30*cos(omega*(t-Tr)) - 30;
  GLCylinder3.PitchAngle := bet;

  t := t + 1;
end;

end.
